<?php

session_start();

function recursive_in_array($needle, $haystack) {
    foreach ($haystack as $stalk) {
        if ($needle === $stalk || (is_array($stalk) && recursive_in_array($needle, $stalk))) {
            return true;
        }
    }
    return false;
}

include_once (PS_ADMIN_DIR . '/../classes/AdminTab.php');

class AdminNewsletter extends AdminTab
{

    public function display()
    {
        global $currentIndex, $cookie;

        if (Tools::getValue('send') != 1)
        {
            $_POST                      =   isset($_SESSION['newsletter']['POST']) ? $_SESSION['newsletter']['POST'] : null;

            $iso = Language::getIsoById(intval($cookie->id_lang));

            echo $this->html = '
		<h2>' . $this->l('Отправка писем') 	. '</h2><p>'  . 
				$this->l('Вы можите указать Имя Фамилию и e-mail получателя:') 	. '   '	.
				$this->l('%FIRSTNAME%') . ' - ' . 
				$this->l('%LASTNAME%') 	. ' - ' . 
				$this->l('%MAIL%') 		. '</p>
		
		<form action="' . $currentIndex . '&token=' . $this->token .
                '&send=1" method="post" >
		<fieldset>
		<legend>'.$this->l('Кому').':</legend><br/>
		<input type="text" name="subject_email" style="width: 100%" value="'.Tools::getValue('subject_email').'" />
		</fieldset>
		
		<br/>
		
		<fieldset>
		<legend>'.$this->l('Текст сообщения').':</legend>
		
		<br/>
						
		<script type="text/javascript" src="../js/tinymce/jscripts/tiny_mce/tiny_mce.js"></script>
                <script type="text/javascript">
            	tinyMCE.init({
            		// General options
            		mode : "textareas",
            		theme : "advanced",
                        languages : "pt",
            		plugins : "safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount",
            
            		// Theme options
            		theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
            		theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
            		theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
            		theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak",
            		theme_advanced_toolbar_location : "top",
            		theme_advanced_toolbar_align : "left",
            		theme_advanced_statusbar_location : "bottom",
            		theme_advanced_resizing : true,
            
            		// Example content CSS (should be your site CSS)
            		content_css : "css/content.css",
            
                        save_enablewhendirty : true,
                        save_onsavecallback : "mysave",
            
            		// Drop lists for link/image/media/template dialogs
            		template_external_list_url : "../js/tinymce/jscripts/tiny_mce/lists/template_list.php",
            		external_link_list_url : "lists/link_list.js",
            		external_image_list_url : "lists/image_list.js",
            		media_external_list_url : "lists/media_list.js",
            
            		// Replace values for the template plugin
            		template_replace_values : {
            			username : "Some User",
            			staffid : "991234"
            		}
            	});
                </script>
		
		<textarea name="body_email" style="width:100%; height: 300px;">
                '.Tools::getValue('body_email').'
		</textarea>

        <br />
        
       <div align="left">

            <h2> Настройки: </h2>
            <div style="margin-left: 15px">
                Сколько отправлять писем в минуту:
                <input type="text" name="wait_time" size="2" value="2" maxlength="2" /></label> <br /><br />
            </div>

            <h2> Тест </h2>
            <div style="margin-left: 15px">
                <input type="checkbox" name="sTeste" value="1" /> Отправить тестовое сообщение? <br /><br /> &nbsp;&nbsp;&nbsp;
                E-mail для теста: <input type="text" name="sMailTest" size="30" /></label> <br /><br />
            </div>

            <h2> Блок подписка на новости </h2>
            <div style="margin-left: 15px">
                <input type="checkbox" name="$sNewsletter" value="1" /> Отправить письма тем кто подписан на новости <br /><br /> &nbsp;&nbsp;&nbsp;
                Имя: <input type="text" name="name_Subscribers" size="30" /> <br /><br /> &nbsp;&nbsp;&nbsp;
                Фамилия: <input type="text" name="lname_Subscribers" size="30" /> <br /><br />
            </div>

            <h2> Зарегистрированные пользователи </h2>
            <div style="margin-left: 15px">
                <input type="radio" name="sCustomers" value="0" checked="checked"  /> Нет <br /><br />
                <input type="radio" name="sCustomers" value="1"  /> Все клиенты <br /><br />
                <input type="radio" name="sCustomers" value="2"  /> Только те кто подписан на новости <br /><br />
                <input type="radio" name="sCustomers" value="3"  /> Клиенты у которых день рождения будет  <br /><br /> &nbsp;&nbsp;&nbsp;
                    <input type="text" size="6" maxlength="5" value="'.date("d-m").'" name="dateBrithday" /> Введите день и месяц
            </div>
        
        </div>
        
        <br />        
                
        <div align="right">                
		<input type="submit" onclick="return confirm(\''.$this->l('Подтвердите отправку писем?').'\');" name="send_newsletter" value="'.$this->l('Отправить письма').'" class="button" />
		</div>
                
		</fieldset>
		</form>
		';

            unset( $_SESSION['newsletter'] );
            $_SESSION['newsletter']['POST']           =   $_POST;
        }
    }

    public function postProcess()
    {
        global $currentIndex, $cookie;

        if (Tools::getValue('send') == 1)
        {
            if( !isset($_SESSION['newsletter']) OR empty($_SESSION['newsletter']['finalList']) ){

                $sCustomers 		= Tools::getValue('sCustomers');
                $sNewsletter 		= Tools::getValue('$sNewsletter');
                $sTeste                 = Tools::getValue('sTeste');
                $sendList               = Array();

                /** Отправить тестовое сообщение **/
                if( $sTeste AND Validate::isEmail(Tools::getValue('sMailTest')) )
                {
                    $array[]            =
                    array( 'email' => Tools::getValue('sMailTest'), 'firstname' => $this->l('Тестовое'), 'lastname' => $this->l('Сообщение') );
                    $sendList           = array_merge($sendList,  $array );
                }
                /** Конец отправки тестового сообщения **/

                /** Отправить пользователям **/
                if ($sCustomers == '1' )
                {
                    $customers 		= Customer::getCustomers();
                    $sendList           = array_merge($sendList, $customers);
                }
                else if ( $sCustomers == '2' )
                {
                    $customers          = Customer::getNewsletteremails();
                    $sendList           = array_merge($sendList, $customers);
                }
                else if( $sCustomers == '3' )
                {
                    $customers          = $this->getBirthdayCustomers( Tools::getValue('dateBrithday') );
                    $sendList           = array_merge($sendList, $customers);
                }
                /** Конец отправки пользователям **/

                /** Отправить подписчика на новости **/
                if ($sNewsletter)
                {
                    $blockSubscribers   = $this->getBlockSubscribers();
                    $sendList           = array_merge($sendList, $blockSubscribers);
                }
                /** Конец отправки подписчикам на новости **/

                $finalList = Array();
                foreach ($sendList as $item){
                    if (!recursive_in_array($item['email'],$finalList))
                        {$finalList[] = $item;}
                }

                $Result['total']            =   0;
                $Result['failed']           =   0;
                $Result['success']          =   0;
                $ArrayFailed                =   array();
                $key                        =   0;
                $output                     =   '';
                $check_division             =   60 / ( intval($_POST['wait_time']) > 0 ? intval($_POST['wait_time']) : 2 ) ;
                $wait                       =   intval( $check_division ) > 0 ? $check_division : 30;

                $_SESSION['newsletter']['check']          =   TRUE;
                $_SESSION['newsletter']['finalList']      =   $finalList;
                $_SESSION['newsletter']['total']          =   $Result['total'];
                $_SESSION['newsletter']['failed']         =   $Result['failed'];
                $_SESSION['newsletter']['success']        =   $Result['success'];
                $_SESSION['newsletter']['ArrayFailed']    =   $ArrayFailed;
                $_SESSION['newsletter']['POST']           =   $_POST;
                $_SESSION['newsletter']['GET']            =   $_GET;
                $_SESSION['newsletter']['key']            =   $key;
                $_SESSION['newsletter']['output']         =   $output;
            }else{
                $finalList                  =   $_SESSION['newsletter']['finalList'];
                $Result['total']            =   $_SESSION['newsletter']['total'];
                $Result['failed']           =   $_SESSION['newsletter']['failed'];
                $Result['success']          =   $_SESSION['newsletter']['success'];
                $ArrayFailed                =   $_SESSION['newsletter']['ArrayFailed'];
                $_POST                      =   $_SESSION['newsletter']['POST'];
                $_GET                       =   $_SESSION['newsletter']['GET'];
                $key                        =   $_SESSION['newsletter']['key']+1;
                $output                     =   $_SESSION['newsletter']['output'];
                
                $check_division             =   60 / ( intval($_POST['wait_time']) > 0 ? intval($_POST['wait_time']) : 2 ) ;
                $wait                       =   intval( $check_division ) > 0 ? $check_division : 30;
            }

            /** GLOBAL **/
            $email_from                     = Configuration::get('PS_SHOP_EMAIL');
            $name                           = Configuration::get('PS_SHOP_NAME');
            /** GLOBAL **/

            if( empty($finalList) ){
                echo '<div class="alert">'.$this->l('Нет получателей с выбранными критериями!').'</div>';
                $_POST['send']  =   0;
                return $this->display();
            }

            $value      = $finalList[$key];

            //%EMAIL% - %NOME% - %SOBRENOME%
            $html 	= Tools::getValue('body_email');
            $assunto 	= Tools::getValue('subject_email');

            $firstname 	= isset($value['firstname']) ? $value['firstname'] : Tools::getValue('name_Subscribers');
            $lastname 	= isset($value['lastname']) ? $value['lastname'] : Tools::getValue('lname_Subscribers');
            $email 	= $value['email'];

            $html 	= str_replace($this->l('%FIRSTNAME%'), $firstname, $html);
            $html 	= str_replace($this->l('%LASTNAME%'),  $lastname, $html);
            $html 	= str_replace($this->l('%MAIL%'),      $email, $html);

            $assunto 	= str_replace($this->l('%FIRSTNAME%'), $firstname, $assunto);
            $assunto 	= str_replace($this->l('%LASTNAME%'),  $lastname, $assunto);
            $assunto 	= str_replace($this->l('%MAIL%'),      $email, $assunto);

            unset($headers);
            $headers        = "MIME-Version: 1.0\r\n";
            $headers 	   .= "Content-type: text/html; charset=iso-8859-1\r\n";
            $headers 	   .= "X-Priority: 1\r\n";
            $headers 	   .= "X-MSMail-Priority: High\r\n";
            $headers 	   .= "Disposition-Notification-To: $email_from\r\n" . $headers .=
                              "Reply-To: $email_from\r\n";
            $headers 	   .= "From: $name <$email_from>\r\n";
            $headers 	   .= "Organization: $name\r\n";

            $mensagem 		= nl2br($html);

            $Mail_Send          = new Mail();
            $send               = false;

            $send 		= Mail::Send(intval($cookie->id_lang), 'newsletter', $assunto, array('{email}' => $email_from, '{message}' => stripslashes($mensagem)), $email);

            $output             .=
            '<tr>
            <td>&nbsp;' . $firstname . '</td>
            <td>&nbsp;' . $lastname . '</td>
            <td>&nbsp;' . $email . '</td>
            <td align="center">';

            if ($send)
            {
                $Result['success']++;
                $output .= "<font color=\"GREEN\"> ".$this->l('Готово!')." </font> <br>";
            } else
            {
                $ArrayFailed[]  =   $value;
                $Result['failed']++;
                $output .=  "<font color=\"RED\"> ".$this->l('Ошибка')." </font> <br>";
            }

            $output .=  ' </td></tr>';

            $Result['total']++;

            $_SESSION['newsletter']['key']            =   $key;
            $_SESSION['newsletter']['output']         =   $output;
            $_SESSION['newsletter']['total']          =   $Result['total'];
            $_SESSION['newsletter']['failed']         =   $Result['failed'];
            $_SESSION['newsletter']['success']        =   $Result['success'];

            $ouput_foot     =    '<tr><td colspan="4">&nbsp;</td></tr>';
            
            $ouput_foot     .=    '<tr><td colspan="2"  ></td><td><b>&nbsp; '.$this->l('Всего отправленно').'</b></td><td align="center">'
            .$Result['total'].'</td><tr>';
            
            $ouput_foot     .=    '<tr><td colspan="2"  ></td><td><b>&nbsp; '.$this->l('Всего доставленно').'</b></td><td align="center">
            <font color="GREEN">'.$Result['success'].'</font></td><tr>';
            
            $ouput_foot     .=    '<tr><td colspan="2"  ></td><td><b>&nbsp; '.$this->l('Всего не доставленно').'</b></td><td align="center">
            <font color="RED">'.$Result['failed'].'</font></td><tr>';

            if( isset($finalList[$key+1]) ){
                echo "<meta http-equiv=\"refresh\" content=\"$wait\" />";
                echo '<div class="alert">'.$this->l('Подождите идет отправка писем').'</div>';
                $button      =   '  ';
            }
            else{
                session_destroy();
                $_SESSION['newsletter']['POST']        =   $_POST;
                echo '<div class="conf">'.$this->l('Готово!').'</div>';
                $button      =   ' <input type="submit" name="back" value="'.$this->l('Назад').'" class="button" /> ';
            }

            $ouput_header                   = '<fieldset>
            <legend>Отчет о доставке</legend><br>
            <table border="1" width="100%" style="border-collapse: collapse;"
            cellpadding="2" bordercolor="#e0d0b1" >
            <tr>
                    <td align="center"><b>'.$this->l('Имя').'</b></td>
                    <td align="center"><b>'.$this->l('Фамилия').'</b></td>
                    <td align="center"><b>'.$this->l('Электронная почта').'</b></td>
                    <td align="center"><b>'.$this->l('Статус').'</b></td>
            </tr>
            ';

            /** BOTÃO VOLTAR **/
            $ouput_foot     .=    '</table>
            </fieldset>
            <form action="' . $currentIndex . '&token=' . $this->token .
            '&send=0" method="post" >
            <div align="right"><br />
                '.$button.'
		</div>
		</form>';

            echo $ouput_header;
            echo $output;
            echo $ouput_foot;

        }
    }

    private function getBirthdayCustomers( $date = null )
    {
        $date               = is_null($date) ? date("d-m") : $date;
        $return             = Db::getInstance()->ExecuteS("
        SELECT
            ps_customer.email,
            ps_customer.lastname,
            ps_customer.firstname
        FROM
            ps_customer
        WHERE
            DATE_FORMAT(ps_customer.birthday, \"%d-%m\") = '$date' ");
        return $return;
    }

    private function getBlockSubscribers()
    {
        $return             = Db::getInstance()->ExecuteS('
        SELECT *
        FROM `'._DB_PREFIX_.'newsletter`; ');
        $bNewsletters = ( is_array($return) ? $return : array() );
        return $return;
    }
}

?>
